enum EntityFlags
{
	EF_BONEMERGE				= 1,
}

enum SolidFlags
{
	FSOLID_CUSTOMRAYTEST		= 1,
	FSOLID_CUSTOMBOXTEST		= 2,
	FSOLID_NOT_SOLID			= 4,
	FSOLID_TRIGGER				= 8,
}

function AddWeapon(player, classname, itemindex, weaponModel, slot)
{
	local weapon = Entities.CreateByClassname(classname)

	NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemindex)
	NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_bInitialized", 1)
	weapon.SetAbsOrigin(Vector(0,0,0))
	weapon.SetAbsAngles(QAngle(0,0,0))

	Entities.DispatchSpawn(weapon)

	local solidFlags = NetProps.GetPropInt(weapon, "m_Collision.m_usSolidFlags");
	NetProps.SetPropInt(weapon, "m_Collision.m_usSolidFlags", solidFlags | SolidFlags.FSOLID_NOT_SOLID);

	if (classname != "tf_wearable")
		NetProps.SetPropEntityArray(player, "m_hMyWeapons", weapon, slot)
	else
		NetProps.SetPropEntityArray(player, "m_hMyWearables", weapon, slot); //todo entity leak
	weapon.SetTeam(player.GetTeam())

	solidFlags = NetProps.GetPropInt(weapon, "m_Collision.m_usSolidFlags");
	NetProps.SetPropInt(weapon, "m_Collision.m_usSolidFlags", solidFlags & ~(SolidFlags.FSOLID_TRIGGER));
    NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_bOnlyIterateItemViewAttributes", 1)

	DoEntFire("!self", "SetParent", "!activator", 0, player, weapon)
	NetProps.SetPropInt(weapon, "m_MoveType", 0)

	local flags = NetProps.GetPropInt(weapon, "m_fFlags");
	NetProps.SetPropInt(weapon, "m_fFlags", flags | EntityFlags.EF_BONEMERGE);

	weapon.SetLocalOrigin(Vector(0,0,0))
	weapon.SetLocalAngles(QAngle(0,0,0))

	NetProps.SetPropEntity(weapon, "m_iState", 0)
	//weapon.SetOwner(player)
	NetProps.SetPropEntity(weapon, "m_hOwner", player)
	NetProps.SetPropEntity(weapon, "m_hOwnerEntity", player)

	local curTime = Time()
    NetProps.SetPropEntity(weapon, "m_flNextPrimaryAttack", curTime)
	NetProps.SetPropEntity(weapon, "m_flNextSecondaryAttack", curTime)

	weapon.SetModel(weaponModel)

	NetProps.SetPropInt(weapon, "m_bValidatedAttachedEntity", 1)

	return weapon;
}