//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class BraveJumpHaleAbility extends HaleAbility
{
    haleJumpStatus = HALE_JUMP_STATUS.WALKING;

    function FrameTick(hale)
    {
        local buttons = NetProps.GetPropInt(hale, "m_nButtons");

        if (!(hale.GetFlags() & Constants.FPlayer.FL_ONGROUND))
        {
            if (haleJumpStatus == HALE_JUMP_STATUS.WALKING)
                haleJumpStatus = HALE_JUMP_STATUS.JUMP_STARTED;
            else if (haleJumpStatus == HALE_JUMP_STATUS.JUMP_STARTED && !(buttons & Constants.FButtons.IN_JUMP))
                haleJumpStatus = HALE_JUMP_STATUS.CAN_DOUBLE_JUMP;
        }
        else
            haleJumpStatus = HALE_JUMP_STATUS.WALKING;

        if (buttons & Constants.FButtons.IN_JUMP && haleJumpStatus == HALE_JUMP_STATUS.CAN_DOUBLE_JUMP)
        {
            //vsh_vscript.PlayVOAtEntity(hale, vsh_vscript.SOUND_VO_SAXTON_JUMP);
            if (!vsh_vscript.IsRoundSetup())
                EmitSoundOn("VSH.Jump", hale);

            haleJumpStatus = HALE_JUMP_STATUS.DOUBLE_JUMPED;
            Perform(hale);
        }
    }

    function Perform(hale)
    {
        local buttons = NetProps.GetPropInt(hale, "m_nButtons");
        local eyeAngles = hale.EyeAngles();
        local forward = eyeAngles.Forward();
        forward.z = 0;
        forward.Norm();
        local left = eyeAngles.Left();
        left.z = 0;
        left.Norm();

        local forwardmove = 0
        if (buttons & Constants.FButtons.IN_FORWARD)
            forwardmove = 1;
        else if (buttons & Constants.FButtons.IN_BACK)
            forwardmove = -1;
        local sidemove = 0
        if (buttons & Constants.FButtons.IN_MOVELEFT)
            sidemove = -1;
        else if (buttons & Constants.FButtons.IN_MOVERIGHT)
            sidemove = 1;

        local newVelocity = Vector(0,0,0);
        newVelocity.x = forward.x * forwardmove + left.x * sidemove;
        newVelocity.y = forward.y * forwardmove + left.y * sidemove;
        newVelocity.Norm();
        newVelocity *= 300;
        newVelocity.z = vsh_vscript.haleJumpForce

        local currentVelocity = hale.GetAbsVelocity();
        if (currentVelocity.z < 300)
            currentVelocity.z = 0;

        NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
        hale.SetAbsVelocity(currentVelocity + newVelocity)
    }
}