//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class SlamHaleAbility extends HaleAbility
{
    inUse = false;
    lastFrameDownVelocity = 0;

    function IsReady(hale)
    {
        return meter == 0;
    }

    function MeterValueAsString()
    {
        if (meter == 0)
            return "Ready";
        else if (meter < 0)
            return format("%.1fs", -meter);
        else
            return format("%d%%", meter * 100);
    }

    function Tick(hale, interval)
    {
        if (meter < 0)
        {
            meter += interval;
            if (meter > 0)
                meter = 0;
        }
        if (vsh_vscript.haleChargeAbility.meter > 0)
            return;
        if (!(hale.GetFlags() & Constants.FPlayer.FL_ONGROUND) && (hale.GetFlags() & Constants.FPlayer.FL_DUCKING))
            Weightdown(hale);
        else if (inUse && !(hale.GetFlags() & Constants.FPlayer.FL_DUCKING))
        {
            inUse = false;
            NetProps.SetPropInt(hale.GetActiveWeapon(), "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 5); //todo future
            //hale.RemoveCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART_DASH);
            hale.SetGravity(1);
        }
        else if (inUse && (hale.GetFlags() & Constants.FPlayer.FL_ONGROUND))
        {
            inUse = false;
            NetProps.SetPropInt(hale.GetActiveWeapon(), "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 5); //todo future
            //hale.RemoveCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART_DASH);
            hale.SetGravity(1);
            if (meter >= 0 && lastFrameDownVelocity < -700)
                Perform(hale);
        }
    }

    function Weightdown(hale)
    {
        inUse = true;
        hale.SetGravity(3);
        lastFrameDownVelocity = hale.GetAbsVelocity().z;
        if (meter >= 0)
        {
            hale.AddCustomAttribute("no_attack", 1, 0.15);
            NetProps.SetPropInt(hale.GetActiveWeapon(), "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 264); //todo future
        }
    }

    function Perform(hale)
    {
        DispatchParticleEffect("hammer_impact_button", hale.GetOrigin() + Vector(0,0,20), Vector(0,0,0));
        EmitSoundOn("VSH.Slam.Impact", hale);
        lastFrameDownVelocity = 0;
        meter = -15;

        local currentWeapon = hale.GetActiveWeapon();
        local mannthreadsWeapon = NetProps.GetPropEntityArray(hale, "m_hMyWeapons", 1);
        NetProps.SetPropEntity(hale, "m_hActiveWeapon", mannthreadsWeapon);

        vsh_vscript.CreateAoE(hale.GetCenter(), 500,
            function (target, deltaVector, distance) {
                local damage = target.GetMaxHealth() * (1 - distance / 500);
                if (damage <= 30 && target.GetMaxHealth() <= 30)
                    return; // We don't want to have people on low health die because Hale just Slammed a mile away.
                target.TakeDamageEx(
                    hale,
                    hale,
                    hale.GetActiveWeapon(),
                    deltaVector,
                    hale.GetOrigin(),
                    target.GetMaxHealth() * (1 - distance / 500),
                    1);
            }
            function (target, deltaVector, distance) {
                local pushForce = distance < 100 ? 1 : 100 / distance;
                deltaVector.x = deltaVector.x * 1250 * pushForce;
                deltaVector.y = deltaVector.y * 1250 * pushForce;
                deltaVector.z = 950 * pushForce;
                target.Yeet(deltaVector);
            });

        NetProps.SetPropEntity(hale, "m_hActiveWeapon", currentWeapon);
        ScreenShake(hale.GetCenter(), 10, 2.5, 1, 1000, 0, true);
    }
}