//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class StunBreakOutHaleAbility extends HaleAbility
{
    haleLastTimeHolidayPunch = 0;

    function Tick(hale, interval)
    {
        if (hale.IsControlStunned() || (Time() - haleLastTimeHolidayPunch <= 4 && hale.InCond(Constants.ETFCond.TF_COND_TAUNTING)))
            meter += interval;
        else if (meter > 0)
            meter -= interval;
        if (meter < 0)
            meter = 0;

        if (meter >= 4)
            Perform(hale);
    }

    function Perform(hale)
    {
        meter = 0;
        EmitSoundOn("VSH.Rage", hale);
        hale.RemoveCond(Constants.ETFCond.TF_COND_STUNNED);
        hale.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
        hale.Yeet(Vector(0,0,800));

        DispatchParticleEffect("hammer_impact_button", hale.GetOrigin() + Vector(0,0,20), Vector(0,0,0));
        EmitSoundOn("VSH.Slam.Impact", hale);

        vsh_vscript.CreateAoE(hale.GetCenter(), 400,
            function (target, deltaVector, distance) {
                target.TakeDamageEx(
                    hale,
                    hale,
                    hale.GetActiveWeapon(),
                    deltaVector,
                    hale.GetOrigin(),
                    1,
                    1);
            }
            function (target, deltaVector, distance) {
                local pushForce = distance < 100 ? 10 : 10 / sqrt(distance);
                deltaVector.x = deltaVector.x * 1450 * pushForce;
                deltaVector.y = deltaVector.y * 1450 * pushForce;
                deltaVector.z = 450 * pushForce;
                target.Yeet(deltaVector);
            });
    }
}