//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class WallClimbChange extends MercChange
{
    function OnTick()
    {
        //if (!player.IsFakeClient() && (player in vsh_vscript.hitStreak))
        //    printl("vsh_vscript.hitStreak[player]="+vsh_vscript.hitStreak[player])
        if ((player.GetFlags() & Constants.FPlayer.FL_ONGROUND))
            vsh_vscript.hitStreak[player] <- 0;
    }

    function OnWeaponFired(weapon)
    {
        //printl("OnWeaponFired and "+GTFW_ReturnWeaponBySlotBool(weapon, TF_WEAPONSLOTS.MELEE))
        if (GTFW_ReturnWeaponBySlotBool(weapon, TF_WEAPONSLOTS.MELEE))
            RunWithDelay("TryClimb(activator, " + CalcLaunchVelocity(player) +")", player, 0.15);
    }

    function CalcLaunchVelocity(player)
    {
        //printl("calc player="+tablevalue(vsh_vscript.hitStreak, player, 0))
        //printl("calc vsh_vscript.hitStreak[player]="+tablevalue(vsh_vscript.hitStreak, player, 0))
        //local value = (player.GetPlayerClass() != TF_CLASS.SCOUT ? 600 : 500) - 100 * tablevalue(vsh_vscript.hitStreak, player, 0);
        local value = player.GetPlayerClass() != TF_CLASS.SCOUT ? 600 : 500;
        //printl("calc value="+value)
        return value > 0 ? value : 0;
    }
}
mercChangesClasses.push(WallClimbChange);

hitStreak <- {};

function TryClimb(player, launchVelocity)
{
    if (CheckClimb(player))
    {
        hitStreak[player] <- tablevalue(hitStreak, player, 0) + 1;
        player.Yeet(Vector(0, 0, launchVelocity));
        RunWithDelay("activator.Yeet(activator.EyeAngles().Forward() * 200)", player, 0.15);
    }
}

function CheckClimb(player)
{
    local startPos = player.Weapon_ShootPosition();
    local endPos = startPos + (player.EyeAngles().Forward() * 70);

    local vecSwingMins = Vector(-18, -18, -18);
    local vecSwingMaxs = Vector(18, 18, 18);

    local primaryTrace = {
        start = startPos,
        end = endPos,
        hullmin = vecSwingMins,
        hullmax = vecSwingMaxs,
        mask = Constants.FContents.CONTENTS_SOLID
          | Constants.FContents.CONTENTS_MOVEABLE
          | Constants.FContents.CONTENTS_WINDOW
          | Constants.FContents.CONTENTS_MONSTER
          | Constants.FContents.CONTENTS_GRATE
          | Constants.FContents.CONTENTS_MONSTERCLIP,
        ignore = player
    };

    local primaryTraceLanded = TraceHull(primaryTrace) && tablevalue(primaryTrace, "hit", false);
    if (!primaryTraceLanded)
        return;

    //Hit Hale - get launched upward.
    local entityHit = tablevalue(primaryTrace, "enthit");
    //if (entityHit == GetHale() && !CanNotClimbOffHale(player, player.GetActiveWeapon()))
    //    return true; //todo some exclusions //todo male this climb only off of damage

    local isBuilding = entityHit != null && entityHit.GetClassname().find("obj_") == 0;
    //Hit engie building - don't get launched.
    if (isBuilding && player.GetPlayerClass() == TF_CLASS.ENGINEER)
        return false;

    //If we hit a player, re-trace without players' collision in search for a wall again.
    //Sadly, this also excludes some stuff like `prop_dynamic`s and `func_brush`es.
    //Well, better than nothing, right?
    local entIndex = entityHit != null ? entityHit.entindex() : -1;
    if (isBuilding || (entIndex > 0 && entIndex <= Constants.Server.MAX_PLAYERS))
    {
        primaryTrace = {
            start = startPos,
            end = endPos,
            hullmin = vecSwingMins,
            hullmax = vecSwingMaxs,
            mask = Constants.FContents.CONTENTS_SOLID
              | Constants.FContents.CONTENTS_MOVEABLE
              | Constants.FContents.CONTENTS_WINDOW
              | Constants.FContents.CONTENTS_GRATE
              | Constants.FContents.CONTENTS_MONSTERCLIP
        };
        if (!(TraceHull(primaryTrace) && tablevalue(primaryTrace, "hit", false)))
            return false;
    }
    return "plane_normal" in primaryTrace &&
        primaryTrace.plane_normal.z < 0.5
        || (primaryTrace.plane_normal.z < 0.71 && !(player.GetFlags() & Constants.FPlayer.FL_ONGROUND));
}

function CanNotClimbOffHale(player, weapon)
{
    return player.GetPlayerClass() == TF_CLASS.SPY
        || weapon == null
        || weapon.Is("market_gardener")
        || weapon.Is("holiday_punch")
        || weapon.Is("any_knife")
}