//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class EngineerSentryChange extends MercChange
{
    sentryDamageAccumulated = 0;

    function CanApply()
    {
        return player.GetPlayerClass() == TF_CLASS.ENGINEER;
    }

    function OnDamageDealt(params)
    {
        if (params.inflictor != null && params.inflictor.GetClassname() == "obj_sentrygun")
        {
            //Nerfing damage and knockback by 50%.
            //There's an attribute that gives sentry resistance, but it doesn't give knockback res
            params.damage *= 0.5;

            //Frontier Justice crits.
            sentryDamageAccumulated += params.damage;
            if (sentryDamageAccumulated >= 500)
            {
                NetProps.SetPropInt(params.inflictor, "SentrygunLocalData.m_iAssists", NetProps.GetPropInt(params.inflictor, "SentrygunLocalData.m_iAssists") + 1);
                sentryDamageAccumulated -= 500;
            }
        }
    }

    /*function OnDeath(params)
    {
        local sentry = null;
        while (sentry = Entities.FindByClassname(sentry, "obj_sentrygun"))
        {
            if (NetProps.GetPropEntity(sentry, "m_hBuilder") == player)
            {
                sentry.TakeDamageEx(
                    null,
                    null,
                    null,
                    Vector(0,0,0),
                    sentry.GetOrigin(),
                    99999,
                    0);
            }
        }
    }*/
}
mercChangesClasses.push(EngineerSentryChange);