//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function HaleAttackedMercEvent(params)
{
    local hale = params.attacker;
    local victim = params.const_entity;

    if (IsNotHale(hale) || params.damage_type == 1 || params.damage_type == 2 || IsHale(victim))
        return;

    haleSaxtonPunchAbility.Perform(hale, victim);
    widePunchAbility.Perform(hale, victim, params.damage);
}
AddListener("damage_hook", HaleAttackedMercEvent, -1);

function MercDiedEvent(params)
{
    if (IsNotValidRound() || IsRoundSetup())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (IsRoundOver())
        return;

    local mercsAlive = GetAliveMercCount();
    if (mercsAlive == 1)
        PlaySoundForAll("VSH.Lastman");
    //else if (RandomInt(1, 10) == 1)
    //    PlaySoundForAll("VSH.Killstreak.General"); //todo less bay leaves
}
AddListener("death", MercDiedEvent, 0);