//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class Sound
{
    soundPath = null;
    count = null;
    extension = null;

    constructor(baseSoundFolder, soundPath, count, extension = ".wav")
    {
        if (soundPath.slice(soundPath.len()-1) != "_")
            soundPath = soundPath + "_";
        if (extension.slice(0,1) != ".")
            extension = "."+extension;

        if (baseSoundFolder != null)
        {
            if (baseSoundFolder.slice(baseSoundFolder.len()-1) != "/")
                baseSoundFolder = baseSoundFolder + "/";
            this.soundPath = baseSoundFolder + soundPath;
        }
        else
            this.soundPath = soundPath;
        this.count = count;
        this.extension = extension;

        for(local i = 1; i <= count; i += 1)
            PrecacheSound(GetSound(i));
    }

    function GetSound(index)
    {
        if (index <= 0)
            return GetRandomSound();
        return soundPath + index + extension;
    }

    function GetRandomSound()
    {
        return GetSound(RandomInt(1, count));
    }

    function GetAllSounds()
    {
        for(local i = 1; i <= count; i += 1)
            yield GetSound(i);
        return null;
    }
}