//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::SAXTON_HALE_MODEL_PATH <- "models/player/saxton_hale.mdl"
::SAXTON_HALE_GLOVES_MODEL_PATH <- "models/player/items/saxton_hale_aura_yellow.mdl"
::SAXTON_HALE_GLOVES2_MODEL_PATH <- "models/player/items/saxton_hale_aura_yellow_megapunch.mdl"
::SAXTON_ARMS_MODEL_PATH <- "models/weapons/c_models/c_saxton_arms.mdl"
::SAXTON_ARMS_MODEL_INDEX <- GetModelIndex("models/weapons/c_models/c_saxton_arms.mdl")

function CacheAssets(void)
{
    PrecacheModel(SAXTON_HALE_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_GLOVES_MODEL_PATH);
    PrecacheModel(SAXTON_HALE_GLOVES2_MODEL_PATH);
    PrecacheModel(SAXTON_ARMS_MODEL_PATH);

    self.PrecacheSoundScript("VSH.Start");
    self.PrecacheSoundScript("VSH.Slam.Impact");
    self.PrecacheSoundScript("VSH.Rage");
    self.PrecacheSoundScript("DemoCharge.HitFlesh");
    self.PrecacheSoundScript("VSH.Jump");
    self.PrecacheSoundScript("VSH.Intro");
    self.PrecacheSoundScript("VSH.HaleWins");
    self.PrecacheSoundScript("VSH.HaleLoses");
    self.PrecacheSoundScript("VSH.Lastman");
    self.PrecacheSoundScript("VSH.Killstreak.General");

    self.PrecacheSoundScript("VSH.Charge1");
    self.PrecacheSoundScript("VSH.Charge2");
    self.PrecacheSoundScript("VSH.Charge3");
    self.PrecacheSoundScript("VSH.ChargeSFX");
    self.PrecacheSoundScript("VSH.Dash1");
    self.PrecacheSoundScript("VSH.Dash2");
    self.PrecacheSoundScript("VSH.Dash3");
    self.PrecacheSoundScript("VSH.DashSFX");
    self.PrecacheSoundScript("VSH.Punch");
    self.PrecacheSoundScript("VSH.PunchSFX");
    self.PrecacheSoundScript("VSH.PunchReadyVO");
    self.PrecacheSoundScript("VSH.PunchReadySFX");

    self.PrecacheSoundScript("ui.crate_open_short");
    self.PrecacheSoundScript("Halloween.spell_pickup");
    self.PrecacheSoundScript("MVM.PlayerUsedPowerup");
    self.PrecacheSoundScript("Building_Teleporter.Send");
    self.PrecacheSoundScript("MVM.SentryBusterStep");
}
CacheAssets(null);